<template>
    <div>
        <v-row>
            <v-col>
                <data-table
                    v-model="items"
                    :title="$tc('order', 2)"
                    :endpoint="`/api/orders`"
                    :headers="headers"
                    :search-label="searchLabel"
                >
                    <template v-slot:item="{ item }">
                        <tr>
                            <td class="text-center">{{ item.id }}</td>
                            <td>{{ item.user.profile.name }}</td>
                            <td>{{ item.user.profile.mobile }}</td>
                            <td class="text-right">
                                {{ item.amount | currency }} <span class="text-uppercase">{{ item.currency }}</span>
                            </td>
                            <td class="text-right">{{ item.business_type.name }}</td>
                            <td>
                                <v-chip
                                    class="status mx-auto"
                                    :class="`status--${item.status.name}`"
                                    text-color="white"
                                    label
                                >
                                    {{ item.pick_up_requested_at && !item.return_at && item.status.id !== partialReturned ? $t('return') : $t(item.status.name) }}
                                </v-chip>
                            </td>
                            <td>{{ item.order_at | date }}</td>
                            <td>
                                <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>
                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                :to="`/order/${item.id}`"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-eye</v-icon>
                                                {{ $t('view') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </td>
                        </tr>
                    </template>
                </data-table>
            </v-col>
        </v-row>
    </div>
</template>

<script>
    import DataTable from "../DataTable";
    import util from '../../../mixins/util';
    import VOrderStatusSelect from "../VOrderStatusSelect";
    import OrderStatus from "../../../constants/order"

    export default {
        name: "Order",
        components: {VOrderStatusSelect, DataTable},
        mixins: [ util ],
        data: () => ({
            loading: false,
            showing: null,
            dialog: false,
            items: []
        }),

        computed: {
            headers() {
                return [
                    { text: this.$t('id'), value: 'id', align: 'center', sortable: false },
                    { text: this.$t('name'), value: 'name', sortable: false },
                    { text: this.$t('mobile'), value: 'mobile', sortable: false },
                    { text: this.$t('amount'), value: 'amount', align: 'right', sortable: false },
                    { text: this.$t('business_type'), value: 'business_type', align: 'right', sortable: false },
                    { text: this.$t('status'), value: 'status', align: 'center', sortable: false },
                    { text: this.$t('order_at'), value: 'order_at', sortable: false },
                    { text: this.$t('action'), value: 'action', sortable: false },
                ];
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('order_', [this.$t('id')]) + this.$t('or', {field: this.$t('tag')})
                })
            },

            shippingAddress() {
                if(this.showing === null) return '';

                const address = this.showing.shipping_address;

                return address.address_1 + ', ' + address.address_2 + '\n'
                    + address.postcode + ', ' + address.city + ', ' + address.state + '\n'
                    + address.country;
            },

            disableDelivered() {
                if(this.showing === null) return false;

                return this.showing.status.id !== 4 || this.showing.status.id === 5;
            },
            partialReturned() {
                return OrderStatus.PARTIAL_RETURNED
            },
        },

        methods: {
            showOrder(order) {
                this.showing = order;
                this.dialog = true;
            },

            closeDialog() {
                this.showing = null;
                this.dialog = false;
            },

            markAsDelivered() {
                this.loading = true;

                axios.put('api/order/delivered/' + this.showing.id)
                    .then(({ data }) => {
                        this.loading = false;
                        this.showing.status.id = 5;
                        this.showing.status.name = 'delivered';
                        this.closeDialog();
                    })
                    .catch(({ response }) => {
                        this.loading = false;
                        this.snackbar.show = true;
                        this.snackbar.color = 'error';
                        this.snackbar.message = response.data.message;
                    })
            }
        }
    }
</script>

<style scoped>
</style>
